﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Chapter18
{
    public partial class CountDownClock : Form
    {
        private CountDown3 _countDown;

        public CountDownClock()
        {
            InitializeComponent();
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            nudSeconds.Enabled = false;
            btnStart.Enabled = false;

            _countDown = new CountDown3((uint)nudSeconds.Value);
            _countDown.Tick += new EventHandler<TickEventArgs>(_countDown_Tick);
            _countDown.Finished += new EventHandler(_countDown_Finished);
            _countDown.Start();
        }

        void _countDown_Tick(object sender, TickEventArgs e)
        {
            this.Invoke(new Action(() => {
                lblTime.Text = string.Format("{0} seconds left", e.Seconds);
            }));
        }

        void _countDown_Finished(object sender, EventArgs e)
        {
            this.Invoke(new Action(() => {
                MessageBox.Show("Countdown finished!", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);

                _countDown.Tick -= _countDown_Tick;
                _countDown.Finished -= _countDown_Finished;

                lblTime.Text = "";
                nudSeconds.Enabled = true;
                btnStart.Enabled = true;
            }));
        }
    }
}
