﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace Chapter32_WinMD
{
    public sealed class Class1
    {
        public string GetGreeting(string name)
        {
            return string.Format("Hello, {0}", name);
        }

        /* Not allowed - System.Random is not a Windows Runtime type
        public Random Random
        {
            get { return new Random(); }
        }
         */

        public static IEnumerable<string> GetTypeNames()
        {
            var systemRuntime = typeof(int).GetType().GetTypeInfo().Assembly;

            return (from t in systemRuntime.ExportedTypes
                    where t.Name.StartsWith("System")
                    select t.Name);
        }

        public event EventHandler<int> Tick;

        public void OnTick(int x)
        {
            var tick = Tick;
            if (tick != null)
                tick(this, x);
        }
    }
}
